﻿using System;

namespace PointLib
{
    public class Point : IEquatable<Point>
    {
        // instance member field
        protected int x, y;
        // static member field
        public static int count = 0;

        // constructor & destructor
        public Point() : this(0, 0) { }
        public Point(int x, int y) { this.x = x; this.y = y; count++; }
        ~Point() { count--; }

        // method
        public void SetPosition(int x, int y) { this.x = x; this.y = y; }
        public void Move(int x, int y) { this.x += x; this.y += y; }

        public virtual void Print() { Console.WriteLine("X={0} Y={1}", x, y); }         // virtual method
        public static int GetCount() { return count; }                                  // static method
        public static Point operator ++(Point p) { ++p.x; ++p.y; return p; }             // operator++ overload
        public static bool operator ==(Point p1, Point p2) { return p1.Equals(p2); }     // operator== overload
        public static bool operator !=(Point p1, Point p2) { return !p1.Equals(p2); }    // operator!= overload
        public override string ToString() { return (String.Format("({0}, {1})", x, y)); } // ToString method override 

        public void SetX(int x) { this.x = x; }
        public void SetY(int y) { this.y = y; }

        public int GetX() { return x; }
        public int GetY() { return y; }

        public override int GetHashCode() { return x ^ y; }
        public override bool Equals(object obj)
        {
            if (!(obj is Point))
                return false;
            return Equals((Point)obj);
        }

        public bool Equals(Point other)
        {
            if (this.x == other.x && this.y == other.y)
                return true;
            return false;
        }
    }
}
