﻿using System;

namespace PointLib
{
    public class Point3D : Point, IEquatable<Point3D>
    {
        // instance member field
        protected int z;

        // constructor & destructor
        public Point3D() : this(0, 0, 0) { }
        public Point3D(int x, int y, int z) : base(x, y) { this.z = z; }
        ~Point3D() { }

        public void SetPosition(int x, int y, int z) { base.SetPosition(x, y); this.z = z; }
        public void Move(int x, int y, int z) { base.Move(x, y); this.z += z; }

        public override void Print() { Console.WriteLine("X={0} Y={1} Z={2}", x, y, z); }   // overrided method
        public static Point3D operator ++(Point3D p) { ++p.x; ++p.y; ++p.z; return p; }      // operator overload
        public static bool operator ==(Point3D p1, Point3D p2) { return p1.Equals(p2); }    // operator== overload
        public static bool operator !=(Point3D p1, Point3D p2) { return !p1.Equals(p2); }   // operator!= overload
        public override string ToString() { return (String.Format("({0}, {1}, {2})", x, y, z)); } // override ToString method

        public void SetZ(int z) { this.z = z; }
        public int GetZ() { return z; }

        public override int GetHashCode() { return x ^ y ^ z; }
        public override bool Equals(object obj)
        {
            if (!(obj is Point3D))
                return false;
            return Equals((Point3D)obj);
        }

        public bool Equals(Point3D other)
        {
            if (this.x == other.x && this.y == other.y && this.z == other.z)
                return true;
            return false;
        }
    }
}
