﻿using System;
using PointLib;

namespace PointTest
{
    class PointTest
    {
        static void Swap(ref Point p1, ref Point p2)        // pass-by-reference, method overloading
        {
            Point p;
            p = p1;
            p1 = p2;
            p2 = p;
        }

        static void Swap(ref Point3D p1, ref Point3D p2)    // pass-by-reference, method overloading
        {
            Point3D p;
            p = p1;
            p1 = p2;
            p2 = p;
        }
        
        static void Main(string[] args)
        {
            Console.Write("p1: ");
            Point p1 = new Point();
            Console.Write("p2: ");
            Point p2 = new Point();
            Console.Write("p3: ");
            Point3D p3 = new Point3D();
            Console.Write("p4: ");
            Point3D p4 = new Point3D();

            p1.SetPosition(10, 10);		// 변수 값 지정
            Console.Write("p1 SetPosition: ");
            p1.Print();				// 현재 좌표 출력
            p1.Move(20, 50);		// 좌표 변경 (점의 위치 이동)
            Console.Write("p1 Move: ");
            p1.Print();				// 현재 좌표 출력

            p2.SetPosition(20, 30); // 변수 값 지정
            Console.Write("p2 SetPosition: ");
            p2.Print();				// 현재 좌표 출력

            //포인터 객체 교환함수 호출
            Console.WriteLine("\nSwap");
            Swap(ref p1, ref p2);
            Console.WriteLine("p1: {0}", p1);
            Console.WriteLine("p2: {0}", p2);

            Console.WriteLine();
            Console.WriteLine("p1.m_nX={0}, p1.m_nY={1}, Point.GetCount()={2}, Point.count={3}", p1.GetX(), p1.GetY(), Point.GetCount(), Point.count);
            Console.WriteLine("p2.m_nX={0}, p2.m_nY={1}, Point.GetCount()={2}", p2.GetX(), p2.GetY(), Point.GetCount());

            // Point3D
            Console.WriteLine();
            p3.SetPosition(30, 40, 50);
            Console.Write("p3 SetPosition: ");
            p3.Print();			// 현재 좌표 출력
            ++p3;
            Console.Write("++p3: ");
            p3.Print();			// 현재 좌표 출력
            p3.Move(20, 30, 40);   // 좌표 변경 (점의 위치 이동)
            Console.Write("p3 Move: ");
            p3.Print();			// 현재 좌표 출력
            Console.WriteLine("Point.GetCount()={0} Point.count={1}", Point.GetCount(), Point.count);

            Console.WriteLine();
            p4.SetPosition(100, 200, 300);
            Console.Write("p4 SetPosition: ");
            p4.Print();			// 현재 좌표 출력
            p4.Move(10, 10, 10);   // 좌표 변경 (점의 위치 이동)
            Console.Write("p4 Move: ");
            p4.Print();			// 현재 좌표 출력

            //포인터 객체 교환함수 호출
            Console.WriteLine("\nSwap");
            Swap(ref p3, ref p4);
            Console.WriteLine("p1: {0}", p3);
            Console.WriteLine("p2: {0}", p4);

            Console.WriteLine();
            Console.WriteLine("p3.m_nX={0}, p3.m_nY={1}, p3.m_nZ={2}, Point.GetCount()={3}, Point.count={4}", p3.GetX(), p3.GetY(), p3.GetZ(), Point.GetCount(), Point.count);
            Console.WriteLine("p4.m_nX={0}, p4.m_nY={1}, p4.m_nZ={2}, Point.count={3}", p4.GetX(), p4.GetY(), p4.GetZ(), Point.count);

            if (p3 == p4)
                Console.WriteLine("p3 == p4");
            if (p3 != p4)
                Console.WriteLine("p3 != p4");

            Console.Write("p5: ");
            Point3D p5 = new Point3D(51, 71, 91);
            p5.Print();			// 현재 좌표 출력
            if (p5 == p4)
                Console.WriteLine("p5 == p4");
        }
    }
}
